(** This is the user accessible static methods of the CP runtime system.
  * Note:  the bodies of these procedures are dummies, this module is
  *        compiled with -special.  The real code is in CPJ.java
  *
  * Version: 7 July 1999 (kjg).
  *)

FOREIGN MODULE CPJ;
  IMPORT RTS;

  VAR newLn- : RTS.NativeString;

  PROCEDURE MkStr*(IN a : ARRAY OF CHAR) : RTS.NativeString;
  (** Construct a java.lang.String from an ARRAY OF CHAR *)

  PROCEDURE MkArr*(s : RTS.NativeString; VAR a : ARRAY OF CHAR);
  (** Construct an ARRAY OF CHAR from a java.lang.String *)

  PROCEDURE JCat*(l,r : RTS.NativeString) : RTS.NativeString;
  (** Concatenate two java.lang.Strings *)

  PROCEDURE GetProperty*(key : RTS.NativeString) : RTS.NativeString;
  (** Get the Java runtime system property belonging to key *)

  PROCEDURE StrToReal*(s : RTS.NativeString; OUT r : REAL; OUT ok : BOOLEAN);
  (** Parse a java.lang.String into an ieee double REAL *)

  PROCEDURE StrToInt*(s : RTS.NativeString; OUT i : INTEGER; OUT ok : BOOLEAN);
  (** Parse a java.lang.String into a CP INTEGER *)

  PROCEDURE ExecResult*(args : ARRAY OF RTS.NativeString) : INTEGER;
  (** Fork and exec using the Java API *)

  PROCEDURE DiagProperties*();

  PROCEDURE DiagClass*(o : ANYPTR); 

END CPJ.
