// (* ========================================================= *)
// (**	Interface to the ILASM Byte-code assembler.		*)
// (*	K John Gough, 10th June 1999				*)
// (*	Modifications:						*)
// (*		Version for GPCP V0.3 April 2000 (kjg)		*)
// (* ========================================================= *)
// (*	The real code is in LightningAsm.cool			*)	
// (* ========================================================= *)
//
//MODULE LightningAsm;
//
//  PROCEDURE Init*(); BEGIN END Init;
//
//  PROCEDURE Assemble*(IN fil : ARRAY OF CHAR; main : BOOLEAN); 
//  BEGIN END Assemble;
//
//END LightningAsm.
// 
// 
//  NOTE: this needs (as at 13-Jun-2000) to be compiled using
//
//  $ csc /t:library /r:System.Diagnostics.dll /r:RTS.dll LightningAsm.cs
// 

using System.Diagnostics;

namespace LightningAsm {

public class LightningAsm {

    private static Process asm = null;
  
    public static void Init() {
	if (asm == null) {
	    asm = new Process();
	    asm.StartInfo.FileName = "ilasm";
	    asm.StartInfo.WindowStyle = ProcessWindowStyle.Minimized;
	}
    }

    public static void Assemble(char[] fil, bool hasMain) {
	int retCode;
	System.String optNm;
	System.String suffx;
	System.String fName = CP_rts.mkStr(fil);
	if (hasMain) {
	    optNm = "/exe /debug ";
	    suffx = ".exe";
	} else {
	    optNm = "/dll /debug ";
	    suffx = ".dll";
	}
	asm.StartInfo.Arguments = optNm + fName + ".il";
	asm.Start();
	asm.WaitForExit();
	retCode = asm.ExitCode;
	if (retCode != 0)
	    System.Console.WriteLine("#gpcp: ilasm FAILED " + retCode);
	else
	    System.Console.WriteLine("#gpcp: created " + fName + suffx);
    }
  }
}
